/**
 * Created by Bosco on 2015/4/28.
 */
var fis = module.exports = require('fis');
var fs=require("fs");
var fgp=require("./fgp.js");
//require("fis-prepackager-gpwidget");

fis.cli.name = 'fghostpig';
fis.cli.info = fis.util.readJSON(__dirname + '/package.json');

fis.config.merge({
    fgp_js: "",
    fgp_css: "",
    fgp_view: "",
    fgp_image:"image",
    fgp_handlebars:"handlebars",
    modules: {
        parser: {
            less: 'less',
            tmpl: 'utc',
            scss: ["node-sass"],
            html: ["gpwidget","gpdebug","gpconst"],
            handlebars: ["gpdebug","gphandlebars","gpconst"],
            js:['gpjs',"gpconst"]

        },
        postprocessor: {
            js: "gpseajswrapper, require-async",
            html: "gppx2rem,require-async",
            css:"gppx2rem"
        },
        prepackager: ["gpseajs","gphtmldepends"],
        spriter: "csssprites",
        postpackager: ['gppjax','gpclean','autoload', 'simple','gpsvn','gpplugin'],
        lint: {
            js: 'jshint'
        }

    },
    roadmap: {
        ext: {
            less: 'css',
            scss: "css"
        },
        path: [
            {
                reg: /^\/node_modules\/.*?$/i,
                release:false
            },
            {
                reg: /^.*\/(lib\/.*)\.(js)$/i,
                isMod: false,
                id: '$1',
                release: '${fgp_js}/$&',
                useDomain: true
            },
            {
                reg: /^\/(.*)\.(js)$/i,
                isMod: true,
                id: '$1',
                release: '${fgp_js}/$&',
                useDomain: true
            },
            {
                reg: /^(.*)mixin\[.less|.scss]$/i,
                release: false
            },
            {
                reg: /^(.*)\.(css|less|scss)$/i,
                release: '${fgp_css}/$&',
                useDomain: true
            },
            {
                reg: "README.md",
                release: false
            },
            {
                reg: '**.handlebars',
                isJsLike: true,
                release:'${fgp_handlebars}/$&'
                //isHtmlLike:true,
            },
            {
                reg: /.*\.(html|jsp|tpl|vm|htm|asp|aspx|php)$/,
                release: '${fgp_view}/$&'
            },
            {
                reg: /.*\.(png|jpg|gif|cur)$/,
                release: '${fgp_image}/$&'
            },
            {
                reg:"**.json",
                useCompile:false,
                useOptimizer:false
            }
        ]
    },
    settings: {
        postprocessor: {

        },
        lint: {
            jshint: {
                camelcase: true,
                curly: true,
                eqeqeq: true,
                forin: true,
                immed: true,
                latedef: true,
                newcap: true,
                noarg: true,
                noempty: true,
                node: true
            }
        },
        optimizer : {
            'uglify-js' : {
                mangle : {
                    //不要压缩require关键字，否则seajs会识别不了require
                    except : [ 'require','seajs' ]
                }
            }
        }
    }
});
fis.config.set('project.watch.exclude', /\.json/);

fis.config.set('project.fileType.text', 'handlebars');

fis.fghostpig={};

fis.fghostpig.seajsconfig=function(obj){
}

fis.config.addpath=function(arr){
    if(arr){
        var path=fis.config.get("roadmap.path");
        for(var n=arr.length-1;n>=0;n--){
            path.unshift(arr[n]);
        }
    }
}

fis.fgp=fgp;





//require("fs").writeFile("text.txt","sdfsdf");